<div class="container">
  <div class="row">
    <div class="col-md-12 align-self-center">
      <div class="card">
        <div class="card-body">
          <h5>Registrieren Sie sich bei ZKpfR</h5>
          <br>
          <form (ngSubmit)="sendRegistrationRequest()" [formGroup]="registrationForm">
            <div class="form-group">
              <label for="emailInput">Email</label>
              <input
                [ngClass]="{
                'is-invalid': (!emailFormField.valid && (emailFormField.dirty || emailFormField.touched)),
                'is-valid': emailFormField.valid
                }"
                class="form-control"
                formControlName="email"
                id="emailInput"
                type="text">
            </div>
            <div *ngIf="emailFormField.invalid && (emailFormField.dirty || emailFormField.touched)">
              <p *ngIf="formControls.email.errors.required" class="validation-message text-danger">
                Dies ist ein Pflichtfeld
              </p>
              <p *ngIf="formControls.email.errors.pattern" class="validation-message text-danger">
                Bitte geben Sie eine gültige Email Adresse an
              </p>
              <p *ngIf="!formControls.email.errors.emailAvailable
                  &&!formControls.email.errors.required
                  &&!formControls.email.errors.pattern"
                 class="validation-message text-danger">
                Diese Email Adresse existiert bereits!
              </p>
            </div>
            <div *ngIf="emailFormField.pending">
              <p class="validation-message">
                Email wird überprüft...
              </p>
            </div>
            <div class="form-group">
              <label for="usernameInput">Username</label>
              <input
                [ngClass]="{
                'is-invalid': (!usernameFormField.valid && (usernameFormField.dirty || usernameFormField.touched)),
                'is-valid': usernameFormField.valid
                }"
                class="form-control"
                formControlName="username"
                id="usernameInput"
                type="text">
            </div>
            <div *ngIf="usernameFormField.invalid && (usernameFormField.dirty || usernameFormField.touched)">
              <p *ngIf="formControls.username.errors.required" class="validation-message text-danger">
                Dies ist ein Pflichtfeld
              </p>
              <p *ngIf="formControls.username.errors.minlength" class="validation-message text-danger">
                Der Username muss mindestens 4 Zeichen lang sein
              </p>
              <p *ngIf="!formControls.username.errors.usernameAvailable
                        && !formControls.username.errors.minlength
                        && !formControls.username.errors.required"
                 class="validation-message text-danger">
                Dieser Nutzername existiert bereits!
              </p>
            </div>
            <div *ngIf="usernameFormField.pending">
              <p class="validation-message">
                Nutzername wird geprüft...
              </p>
            </div>
            <div class="form-group">
              <label for="passwordInput">Passwort</label>
              <input
                [ngClass]="{
                'is-invalid': (!passwordFormField.valid && (passwordFormField.dirty ||passwordFormField.touched)),
                'is-valid': passwordFormField.valid
                }"
                aria-describedby="passwordSub"
                class="form-control"
                formControlName="password"
                id="passwordInput"
                type="password">
              <small class="form-text" id="passwordSub">
                Passwort muss mindestens 8 Zeichen enthalten:
                1 Klein-, 1 Großbuchtaben, 1 Sonderzeichen, 1 Zahl.
              </small>
            </div>
            <div class="form-check">
              <input
                class="form-check-input"
                formControlName="rememberMe"
                id="userWantsToBeRemembered"
                type="checkbox"
                value="">
              <label class="form-check-label" for="userWantsToBeRemembered">
                Eingeloggt bleiben
              </label>
            </div>
            <br>
            <div class="text-center">
              <button [disabled]="!registrationForm.valid" class="btn btn-danger" type="submit">Registrieren</button>
              <br>
              <hr>
              <p>Sie hast bereits einen Account?</p>
              <a routerLink="/signin" routerLinkActive="active">Einloggen</a>
            </div>
          </form>
        </div>
      </div>
    </div>
  </div>
</div>
